package com.gmail.pedrolucasnascimentoc;

import java.util.logging.Logger;

import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.block.Block;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.material.Rails;
import org.bukkit.util.Vector;
import com.bergerkiller.bukkit.tc.controller.MinecartGroupStore;



public class Comandos implements CommandExecutor {

	Logger log;
	MinecartGroupStore locomotiva;
	Player jogador;
	Block carrinho;
	Vector vel;
	Location coord_trilho;
	Block trilho;
	Rails trilhoData;
	int manipulo;
	Mantem instancia_mantem;
	MinecartEngine plugin;
	Compressor comprime;

	public Comandos(MinecartEngine plugin) {
		this.plugin = plugin;
	}

	public boolean onCommand(CommandSender sender, Command cmd, String commandLabel, String[] args){ 
		jogador = Bukkit.getPlayer(sender.getName());
		if (cmd.getName().equalsIgnoreCase("control")) {
			Locomotiva loco = Locomotiva.pegaLocomotiva(jogador);
			if (args[0].equalsIgnoreCase("start")) {		
				if(!loco.ligaTrem()) {
					sender.sendMessage("O trem esta sem energia no banco de baterias\nReboque at a oficina!");
				}
				return true;
			} else if (args[0].equalsIgnoreCase("stop")) {		

				if(!loco.desligaTrem()) {
					sender.sendMessage("Desligue os sistemas de alta voltagem antes de desligar por completo o trem!");
				}
				return true;
			} else if (args[0].equalsIgnoreCase("panto")) {		
				if(loco.isEletrica()) {
					if(loco.ligaDesligaTrem()) {
						if(loco.isAltaVoltagem()) {
							jogador.sendMessage("The high voltage systems is running");
						} else {
							jogador.sendMessage("High voltage systems turned off");
						}
						return true;
					} else {
						jogador.sendMessage("The high voltage systems can't be turned on without the low voltage systems running!");
					}
				} else {
					jogador.sendMessage("This locomotive is lava powered, try /engine");
				}
				return true;
			} else if (args[0].equalsIgnoreCase("engine")) {		
				if(!loco.isEletrica()){
					if(loco.ligaDesligaTrem()) {
						if(loco.isAltaVoltagem()) {
							jogador.sendMessage("The high voltage systems is running");
						} else {
							jogador.sendMessage("High voltage systems turned off");
						}
						return true;
					} else {
						jogador.sendMessage("The high voltage systems can't be turned on without the low voltage systems running!");
					}
				} else {
					jogador.sendMessage("This locomotive is electric powered, try /panto");
				}

				return true;
			}
		}

		if(cmd.getName().equalsIgnoreCase("dn")) {
			Locomotiva.pegaLocomotiva(jogador).setDirecao(0, jogador);
			return true;
		} else if(cmd.getName().equalsIgnoreCase("db")) {
			Locomotiva.pegaLocomotiva(jogador).setDirecao(-1, jogador);
			return true;
		} else if(cmd.getName().equalsIgnoreCase("df")) {
			Locomotiva.pegaLocomotiva(jogador).setDirecao(1, jogador);
			return true;
		} else if (cmd.getName().equalsIgnoreCase("p1")) {
			Locomotiva.pegaLocomotiva(jogador).aplicaPonto(1,jogador);
			return true;
		} else if (cmd.getName().equalsIgnoreCase("p2")) {
			Locomotiva.pegaLocomotiva(jogador).aplicaPonto(2,jogador);
			return true;
		} else if (cmd.getName().equalsIgnoreCase("p3")) {
			Locomotiva.pegaLocomotiva(jogador).aplicaPonto(3,jogador);
			return true;
		} else if (cmd.getName().equalsIgnoreCase("p4")) {
			Locomotiva.pegaLocomotiva(jogador).aplicaPonto(4,jogador);
			return true;
		} else if (cmd.getName().equalsIgnoreCase("neutral")) {
			//World mundo = ((CraftWorld) jogador.getWorld()).getHandle();
			//LightUtil.setLightLevel(jogador.getLocation(), (short) 14);
			Locomotiva.pegaLocomotiva(jogador).aplicaNeutro(jogador);
			return true;
		} else if (cmd.getName().equalsIgnoreCase("b1")) {
			Locomotiva.pegaLocomotiva(jogador).aplicaFreio(1,jogador);
			return true;
		} else if (cmd.getName().equalsIgnoreCase("b2")) {
			Locomotiva.pegaLocomotiva(jogador).aplicaFreio(2,jogador);
			return true;
		} else if (cmd.getName().equalsIgnoreCase("b3")) {
			Locomotiva.pegaLocomotiva(jogador).aplicaFreio(3,jogador);
			return true;
		} else if (cmd.getName().equalsIgnoreCase("b4")) {
			Locomotiva.pegaLocomotiva(jogador).aplicaFreio(4,jogador);
			return true;
		}
		return false;
	}
}