package com.gmail.pedrolucasnascimentoc;

import java.util.Iterator;

import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.vehicle.VehicleEnterEvent;

import com.bergerkiller.bukkit.tc.controller.MinecartGroup;

public class OuvidorMinecart implements Listener {
	MinecartEngine principal;

	public OuvidorMinecart(MinecartEngine principal) {
		this.principal = principal;
	}

	@EventHandler
	public void aoEntrar(VehicleEnterEvent minecart) {
		boolean eleMesmo = false;
		Locomotiva instanciaLocomotiva = null;
		MinecartGroup tremDaLocomotiva = null;
		MinecartGroup tremDoJogador = null;
		Iterator passa = principal.getLocomotivas().iterator();
		while(passa.hasNext()) {
			instanciaLocomotiva = ((Locomotiva) passa.next());
			tremDaLocomotiva = instanciaLocomotiva.getLocomotiva();
			tremDoJogador = MinecartGroup.get(minecart.getVehicle());
			if(tremDaLocomotiva.contains(tremDoJogador.get(0))) {
				eleMesmo = true;
				break;
			}
		}
		if(eleMesmo) {
			instanciaLocomotiva.mapa((Player) minecart.getEntered());
		}
	}

}