package com.gmail.pedrolucasnascimentoc;

import java.util.Iterator;
import org.bukkit.block.Block;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockRedstoneEvent;

public class OuvidorMudancaBloco implements Listener {
	MinecartEngine principal;

	public OuvidorMudancaBloco(MinecartEngine principal) {
		this.principal = principal;
	}

	@EventHandler
	public void aoMudarBloco(BlockRedstoneEvent bloco) {
		Block bloco_mudado = bloco.getBlock();
		if(bloco_mudado.getTypeId() == 69) {
			Iterator i  = principal.getSubestacoes().iterator();
			while(i.hasNext()) {
				Subestacao substation = (Subestacao) i.next();
				if(substation.getPosicaoLev().getX() == bloco_mudado.getLocation().getX() &&
						substation.getPosicaoLev().getY() == bloco_mudado.getLocation().getY() &&
						substation.getPosicaoLev().getZ() == bloco_mudado.getLocation().getZ()) {
					if(substation.isLigado()) {
						substation.desliga();
					} else {
						substation.liga();
					}
				}
			}
		}	
	}
}
