package com.gmail.pedrolucasnascimentoc.render;


import java.text.DecimalFormat;

import org.bukkit.entity.Entity;
import org.bukkit.entity.Player;
import org.bukkit.map.MapCanvas;
import org.bukkit.map.MapRenderer;
import org.bukkit.map.MapView;
import org.bukkit.map.MapPalette;
import org.bukkit.map.MinecraftFont;

import com.bergerkiller.bukkit.tc.controller.MinecartMember;
import com.gmail.pedrolucasnascimentoc.Locomotiva;
import com.gmail.pedrolucasnascimentoc.MinecartEngine;

public class Renderizador extends MapRenderer {

	public static Locomotiva locomotiva;
	int contador = 100;
	boolean primeira = true;
	public static MinecartEngine principal;
	private boolean ligado = true;
	private int lado;
	private int col;
	private int direcao;

	@Override
	public void render(MapView mapa, MapCanvas tela, Player jogador) {	
		if(primeira) {
			mapa.setCenterX(700000000);

			for (int x = 0; x < 128; ++x) {
				for (int y = 0; y < 128; ++y) {
					tela.setPixel(x, y, (byte) 10);
				}
			}
			try {
				tela.drawImage(1, 20, Imagens.display[0]);
				this.numero(tela, 2, 50, 10);
				this.numero(tela, 2, 61, 10);
				this.numero(tela, 2, 72, 10);
			} catch (Exception e) {
			}
		}
		if(contador >= 100) {
			if(!locomotiva.isBaixaVoltagem()) {
				mapa.setCenterX(700000000);
				for (int x = 0; x < 128; ++x) {
					for (int y = 0; y < 128; ++y) {
						tela.setPixel(x, y, (byte) 10);
					}
				}
				try {
					tela.drawImage(1, 20, Imagens.display[0]);
					this.numero(tela, 2, 50, 10);
					this.numero(tela, 2, 61, 10);
					this.numero(tela, 2, 72, 10);
				} catch (Exception e) {
				}
			} else {
				//if(this.primeira || tela.getPixel(2, 21) == MapPalette.DARK_BROWN && this.locomotiva.isBaixaVoltagem()) {
				try{
					inicializaSistemas(tela);
				} catch (Exception e) { }
				//}
				pressao(tela);
				try {
					velocimetro(tela);
				} catch (Exception e) { }
				//col = 3;
				//if(this.locomotiva.getFormacaoMinecartMember().length % 2 != 0) {
				//	col = col + 9;
				//}
				col = 64 - (this.locomotiva.getTamanho() * 18) / 2;
				formacao(tela, col, 23, jogador);

			}
			this.contador = 0;
		} else {
			this.contador++;
		}
		primeira = false;
	}

	private void inicializaSistemas(MapCanvas tela) {
		tela.drawImage(1, 20, Imagens.display[1]);
		pressao(tela);
	}

	private void pressao(MapCanvas tela) {
		try { 
			DecimalFormat formatador = new DecimalFormat("000.0");  
			tela.drawText(3, 58, MinecraftFont.Font, formatador.format(locomotiva.getPressaoTambor()) + "PSI");
		} catch (Exception e) { }
	}

	private void velocimetro(MapCanvas tela) {
		DecimalFormat formatador = new DecimalFormat("0.00"); 
		double velocidade = Math.abs(locomotiva.getLocomotiva().getAverageForce());
		String velo = formatador.format(velocidade);
		try {
			velo = velo.substring(0, 4);
		} catch (Exception e1) {
			try {
				velo = velo.substring(0, 3);
			} catch (Exception e2) {
				try {
					velo = velo.substring(0, 1);
				} catch (Exception e3) {

				}
			}
		}
		short primeiro = 0;
		short segundo = 0;
		short terceiro = 0;
		try {
			primeiro = (short) Integer.parseInt(velo.substring(3, 4));
		} catch (Exception e) {
		}
		try {
			segundo = (short) Integer.parseInt(velo.substring(2, 3));
		} catch (Exception e) {
		}
		try {
			terceiro = (short) Integer.parseInt(velo.substring(0, 1));
		} catch (Exception e) {
		}
		this.numero(tela, 2, 72, primeiro);
		this.numero(tela, 2, 61, segundo);
		this.numero(tela, 2, 50, terceiro);

	}

	private void formacao(MapCanvas tela, int coluna , int linha, Player jogador) {
		int col = coluna;
		boolean passageiroTaNoMinecart = false;
		Entity passageiroDoMinecart = null;
		MinecartMember minecart = null;
		for (int i = 0; i <= (this.locomotiva.getFormacaoVirtual().length - 1); i++) {
			passageiroTaNoMinecart = false;
			minecart = this.locomotiva.getFormacaoMinecartMember()[i];
			passageiroDoMinecart = minecart.getMinecart().getPassenger();
			passageiroTaNoMinecart = jogador.equals((Entity) passageiroDoMinecart);
			if(this.locomotiva.getFormacaoVirtual()[i] == 4 && i == 0 || i == (this.locomotiva.getFormacaoVirtual().length - 1)) {
				if(passageiroTaNoMinecart){
					if (this.lado != -1 && i == (this.locomotiva.getFormacaoVirtual().length - 1)){
						if(passageiroTaNoMinecart && this.locomotiva.getDirecao() < 0) {
							//if(/*this.lado != -1 || */this.direcao != -1 || this.primeira) {
							try {
								tela.drawImage(col, linha, Imagens.trem[6]);
							} catch (Exception e) { }
							//this.direcao = -1;
							//}
						} else if(passageiroTaNoMinecart && this.locomotiva.getDirecao() >= 0) {
							//if(/*this.lado != -1 || */this.direcao != 1 || this.primeira) {
							try {
								tela.drawImage(col, linha, Imagens.trem[5]);
							} catch (Exception e) { }
							//this.direcao = 1;
							//}
						}
						//this.lado = -1;
					} else if(i == 0) {
						if(passageiroTaNoMinecart && this.locomotiva.getDirecao() < 0) {
							//if(this.lado != 1 || this.direcao != -1 || this.primeira) {
							try {
								tela.drawImage(col, linha, Imagens.trem[5]);
							} catch (Exception e) { }
							//	this.direcao = -1;
							//}
						} else if (passageiroTaNoMinecart && this.locomotiva.getDirecao() >= 0) {
							//if(this.lado != 1 || this.direcao != 1 || this.primeira) {
							try {
								tela.drawImage(col, linha, Imagens.trem[6]);
							} catch (Exception e) { }
							//}
							//this.direcao = 1;
						}
						//this.lado = 1;
					}
				} else {
					try {
						tela.drawImage(col, linha, Imagens.trem[4]);
					} catch (Exception e) { }
					//this.direcao = 0;
					//this.lado = 0;
				}
			}

			if(this.locomotiva.getFormacaoVirtual()[i] == 3) { 
				if(this.locomotiva.isAltaVoltagem()/* && !this.ligado*/) {
					try {
						tela.drawImage(col, linha, Imagens.trem[7]);
					} catch (Exception e) { }
					//this.ligado = true;
				} else if (!this.locomotiva.isAltaVoltagem()/* && this.ligado*/){
					try {
						tela.drawImage(col, linha, Imagens.trem[3]);
						//this.ligado = false;
					} catch (Exception e) { }
				}
			}
			if(this.locomotiva.getFormacaoVirtual()[i] >= 0 && this.locomotiva.getFormacaoVirtual()[i] <= 2 && i != (this.locomotiva.getFormacaoVirtual().length - 1) && i != 0){ 
				try {
					tela.drawImage(col, linha, Imagens.trem[this.locomotiva.getFormacaoVirtual()[i]]);
				} catch (Exception e) { }
			}
			col = col + 18;
		}
	}

	private void numero(MapCanvas tela, int posY, int posX, int numero) {
		for (int x = posX; x < (posX + 10); ++x) {
			for (int y = posY; y < (posY + 15); ++y) {
				tela.setPixel(x, y, MapPalette.DARK_GRAY);
			}
		}
		if(numero == 8 ||
				numero == 5 ||
				numero == 2 ||
				numero == 3 ||
				numero == 6 ||
				numero == 7 ||
				numero == 9 ||
				numero == 0) {
			for (int x = (posX + 2); x < (posX + 8); ++x) { //primeira linha
				tela.setPixel(x, (posY + 1), MapPalette.WHITE);
			}
		}
		if(numero == 8 ||
				numero == 2 ||
				numero == 5 ||
				numero == 3 ||
				numero == 4 ||
				numero == 6 ||
				numero == 9) {
			for (int x = (posX + 2); x < (posX + 8); ++x) { //segunda linha
				tela.setPixel(x, (posY + 7), MapPalette.WHITE);
			}
		}
		if(numero == 8 ||
				numero == 2 ||
				numero == 3 ||
				numero == 5 ||
				numero == 6 ||
				numero == 9 ||
				numero == 0) {
			for (int x = (posX + 2); x < (posX + 8); ++x) { //terceira linha
				tela.setPixel(x, (posY + 13), MapPalette.WHITE);
			}
		}
		if(numero == 8 ||
				numero == 4 ||
				numero == 5 ||
				numero == 6 ||
				numero == 9 ||
				numero == 0) {
			for (int y = (posY + 2); y < (posY + 7); ++y) { //coluna superior esquerda
				tela.setPixel((posX + 1), y, MapPalette.WHITE);
			}
		}
		if(numero == 8 ||
				numero == 0 ||
				numero == 1 ||
				numero == 2 ||
				numero == 3 ||
				numero == 4 ||
				numero == 7 ||
				numero == 9) {
			for (int y = (posY + 2); y < (posY + 7); ++y) { //coluna superior direita
				tela.setPixel((posX + 8), y, MapPalette.WHITE);
			}
		}
		if(numero == 8 ||
				numero == 2 ||
				numero == 6 ||
				numero == 0) {
			for (int y = (posY + 8); y < (posY + 13); ++y) { //coluna inferior esquerda
				tela.setPixel((posX + 1), y, MapPalette.WHITE);
			}
		}
		if(numero == 8 ||
				numero == 1 ||
				numero == 3 ||
				numero == 4 ||
				numero == 5 ||
				numero == 6 ||
				numero == 7 ||
				numero == 9 ||
				numero == 0) {
			for (int y = (posY + 8); y < (posY + 13); ++y) { //coluna inferior direita
				tela.setPixel((posX + 8), y, MapPalette.WHITE);
			}
		}
	}
}