package com.gmail.pedrolucasnascimentoc;
import com.bergerkiller.bukkit.tc.controller.MinecartGroup;

import java.util.concurrent.TimeUnit;

import org.bukkit.entity.Player;

public class Aceleracao extends Thread {

	MinecartGroup locomotiva;
	double vfinal;
	double vinicial;
	double maxvelo;
	int tempo;
	boolean roda;
	int sentido;
	Mantem instancia_mantem;
	Player maquinista;

	public void SetAceleracao(double vfinal, double vinicial, double velocidade_max, int tempo_aceleracao_max, MinecartGroup locomotiva, int direcao, Player maquinista) {
		this.tempo = tempo_aceleracao_max;
		this.vinicial = vinicial;
		this.vfinal = vfinal;
		this.locomotiva = locomotiva;
		this.sentido = direcao;
		this.maxvelo = velocidade_max;
		this.maquinista = maquinista;
	}

	public void run() {
		roda = true;
		boolean executa = true;
		boolean MaquinistaEhCabeca = false;
		double tempovelomax = TimeUnit.MILLISECONDS.convert(this.tempo, TimeUnit.SECONDS);
		double enquanto = 0;
		double comeca = 0;
		if(locomotiva.getAverageForce() != 0) {
			comeca = (tempovelomax * this.vinicial) / this.maxvelo;
		}
		if(this.vfinal <= this.maxvelo) {
			enquanto = (tempovelomax * this.vfinal) / this.maxvelo; 
		} else {
			enquanto = this.maxvelo;
			executa = false;
		}
		if(executa){
			comeca = this.vinicial * enquanto;

			for(double i = comeca;i <= enquanto && roda; i = i + 100) {
				double a = 0;
				MaquinistaEhCabeca = this.locomotiva.head().getMinecart().equals((Object) this.maquinista.getVehicle());
				a = (this.maxvelo * i) / tempovelomax;
				if(this.locomotiva.getAverageForce() <= a) {
					if(this.locomotiva.getAverageForce() < 0.02){
						if(!MaquinistaEhCabeca && this.sentido > 0) {
							this.locomotiva.reverse();
						} else if(MaquinistaEhCabeca && this.sentido < 0) {
							this.locomotiva.reverse();
						} 	
					}
					this.locomotiva.setForwardForce(a);
				}				
				try {
					Aceleracao.sleep(100);
				} catch (InterruptedException e) {
				}
			}
		}
		if(this.roda && executa) {
			this.instancia_mantem = new Mantem();
			this.instancia_mantem.setMantem(this.vfinal, this.locomotiva, this.maquinista);
			this.instancia_mantem.start();
		}
	}

	public Mantem getinstancia_mantem() {
		return this.instancia_mantem;
	}

	public void ParaThread() {
		this.roda = false;
	}
}