package com.gmail.pedrolucasnascimentoc;

import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import com.bergerkiller.bukkit.tc.controller.MinecartGroup;

public class CriaLocomotiva implements CommandExecutor {
	private MinecartEngine plugin;


	CriaLocomotiva(MinecartEngine plugin) {
		this.plugin = plugin;
	}

	public boolean onCommand(CommandSender sender, Command cmd, String commandLabel, String[] args){
		if(cmd.getName().equalsIgnoreCase("loco") && args[0].equalsIgnoreCase("create")) {
			Player jogador = Bukkit.getPlayer(sender.getName());
			MinecartGroup trem = MinecartGroup.get(jogador.getVehicle());
			boolean eletrica = false;
			int v = 0;
			if(args[1].equalsIgnoreCase("electric")) {
				eletrica = true;
				v = Integer.parseInt(args[2]);
			} else if(args[1].equalsIgnoreCase("lava") || args[1].equalsIgnoreCase("coal") || args[1].equalsIgnoreCase("steam") || args[1].equalsIgnoreCase("diesel")) {
				eletrica = false;
				v = 0;
			}
			
			
			Locomotiva engine = new Locomotiva(trem, eletrica, v, this.plugin);
			this.plugin.getLocomotivas().add(engine);
			if(eletrica) {
				sender.sendMessage("Created electric locomotive with " + engine.getPotencia() + "HP of power\n" +
						"and " + engine.getConsumo() + "HP of electric power consumption.\n" +
						"Designed to run in " + engine.getVoltagem() + "V lines, rain or shine!" +
						"\nBe happy!");
			} else {
				sender.sendMessage("Created lava locomotive with " + engine.getPotencia() + "HP of power\nand " +
						engine.getCapacidadeCombustivel() + " of fuel capacity.\nBe happy!");
			}
			return true;
		}
		return false; 
	}
}
