package com.gmail.pedrolucasnascimentoc;

import java.io.File;
import org.bukkit.Bukkit;
import org.bukkit.DyeColor;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.event.Listener;
import org.bukkit.material.Lever;

public class CriaSubestacao implements CommandExecutor, Listener {
	boolean podeConstruirTransformador = false;
	boolean podeConstruirConexao = false;
	boolean podeConstruirDisjuntor = false;
	World mundo;
	Player jogador;
	MinecartEngine plugin;
	Location conexao;
	Location transformador;
	Location alavanca;
	String nome;
	double potencia;
	double voltagem;
	Subestacao substation;
	File subsList;

	CriaSubestacao(MinecartEngine plugin) {
		this.plugin = plugin;
	}


	public void constroiSubestacao(Block bloco_colocado) {
		if(podeConstruirTransformador){
			double X = 0;
			double Y = 0;
			double Z = 0;
			X = bloco_colocado.getLocation().getX();
			Y = bloco_colocado.getLocation().getY();
			Z = bloco_colocado.getLocation().getZ();
			for(double i2 = Y; i2 <= (Y + 1); i2++){
				for(double i = (X - 1); i <= (X + 1); i++){
					new Location(mundo, i, i2, (Z + 1)).getBlock().setTypeId(113);
				}
				for(double i = (X - 1); i <= (X + 1); i++){
					new Location(mundo, i, i2, (Z - 1)).getBlock().setTypeId(113);
				}
				new Location(mundo, (X + 1), i2, Z).getBlock().setTypeId(113);
				new Location(mundo, (X - 1), i2, Z).getBlock().setTypeId(113);
			}
			new Location(mundo, X, (Y + 1), Z).getBlock().setTypeId(113);
			new Location(mundo, (X + 1), (Y + 2), Z).getBlock().setTypeId(76);
			new Location(mundo, (X - 1), (Y + 2), Z).getBlock().setTypeId(76);
			this.transformador = bloco_colocado.getLocation();
			jogador.sendMessage("Now place a iron block near the track and the catenary");			
			podeConstruirConexao = true;
		}
		podeConstruirTransformador = false;
	}

	public void constroiConexao(Block bloco_colocado) {
		if(podeConstruirConexao) {
			conexao = bloco_colocado.getLocation();
			jogador.sendMessage("Now place a switch in a Wall for manage the substation");
			podeConstruirDisjuntor = true;
		}
		podeConstruirConexao = false;
	}

	public void constroiDisjuntor(Block bloco_colocado) {
		if(podeConstruirDisjuntor){
			double X = bloco_colocado.getLocation().getX();
			double Y = bloco_colocado.getLocation().getY();
			double Z = bloco_colocado.getLocation().getZ();
			new Location(mundo, X, (Y + 1), Z).getBlock().setTypeId(35);
			byte laData = DyeColor.BLACK.getData();
			new Location(mundo, X, (Y + 1), Z).getBlock().setData(laData);
			this.alavanca = new Location(mundo, X, Y, Z);
			Lever alavancaData = new Lever(69, this.alavanca.getBlock().getData());
			alavancaData.setPowered(false);
			this.alavanca.getBlock().setTypeIdAndData(69, alavancaData.getData(), false);
			substation = new Subestacao(this.potencia, this.voltagem, this.conexao, this.transformador, this.alavanca, this.nome, this.plugin);
			jogador.sendMessage("Substation created with success!");
			plugin.getSubestacoes().add(substation);
		}
		podeConstruirDisjuntor = false;
	}
	
	@Override
	public boolean onCommand(CommandSender jogador, Command comando, String etiqueta, String[] parametros) {
		if(comando.getName().equalsIgnoreCase("substation") && parametros[0].equalsIgnoreCase("create")
				&& Double.parseDouble(parametros[2]) > 0 && Double.parseDouble(parametros[2]) <= 25000 &&
				Double.parseDouble(parametros[3]) > 0 && Double.parseDouble(parametros[3]) <= 20000) {
			this.nome = parametros[1];
			this.voltagem = Double.parseDouble(parametros[2]);
			this.potencia = Double.parseDouble(parametros[3]);
			jogador.sendMessage("Place a redstone torch in the local you want to create the substation");
			podeConstruirTransformador = true;
			this.jogador = Bukkit.getPlayer(jogador.getName());
			mundo = this.jogador.getWorld();
			return true;
		}
		return false;
	}

}
