package com.gmail.pedrolucasnascimentoc;

import com.bergerkiller.bukkit.tc.controller.MinecartGroup;
import java.util.concurrent.TimeUnit;

import org.bukkit.Location;
import org.bukkit.entity.Player;

public class Desaceleracao extends Thread {

	MinecartGroup locomotiva;
	double vinicial;
	int stoptime;
	public boolean roda;
	double maxvelo;
	double fator;
	Player maquinista;
	private boolean parada_total;

	public void SetDesaceleracao(double fator, double velocidade, int tempo_desaceleracao_max, double velocidade_maxima, MinecartGroup locomotiva, Player maquinista, boolean parada_total) {
		this.vinicial = velocidade;
		this.parada_total = parada_total;
		this.fator = fator;
		this.stoptime = tempo_desaceleracao_max;
		this.locomotiva = locomotiva;
		this.maxvelo = velocidade_maxima;
		this.maquinista = maquinista;
	}

	public void run() {
		roda = true;
		double tempo_parada = TimeUnit.MILLISECONDS.convert(this.stoptime, TimeUnit.SECONDS);
		double comeca = 0;
		if(locomotiva.getAverageForce() != 0) {
			comeca = (tempo_parada * this.vinicial) / this.maxvelo;
		} else {
			roda = false;
		}
		for(double i = comeca;i > 0 && roda; i = i - this.fator) {
			double a = (this.maxvelo * i) / tempo_parada;
			this.locomotiva.setForwardForce(a);
			try {
				Aceleracao.sleep(100);
			} catch (InterruptedException e) {
			}
		}
		
		if(roda && parada_total){
			locomotiva.setForwardForce(0);
			Locomotiva trem = Locomotiva.pegaLocomotiva(locomotiva.get(0));
			Location[] lugares = new Location[(int) locomotiva.length()];
			for(int i = 0; i <= (trem.tamanho - 1) ;i++) {
				lugares[i] = locomotiva.get(i).getMinecart().getLocation();
			}
			Para parado = new Para(trem, locomotiva, lugares);
			parado.run();			
		}
	}

	public void ParaThread() {
		this.roda = false;
	}
}
