package com.gmail.pedrolucasnascimentoc;
import java.util.ArrayList;
import java.util.logging.Logger;
import org.bukkit.plugin.java.JavaPlugin;

import com.gmail.pedrolucasnascimentoc.render.Imagens;

public class MinecartEngine extends JavaPlugin {
	Logger log;
	Comandos executa_comando;
	CriaSubestacao subestacao;
	OuvidorColocarBloco ouveColocaBloco;
	OuvidorMudancaBloco ouveMudaBloco;
	OuvidorMinecart ouveMinecart;
	Para breque;
	CriaLocomotiva criaLocomotiva;
	ArrayList subestacoes;
	ArrayList locomotivas;
	OuvidorDestruicao ouveDestruicao;
	Imagens sprites;


	public ArrayList getSubestacoes() {
		return subestacoes;
	}

	public CriaSubestacao getSubestacao() {
		return subestacao;
	}

	public void onEnable(){
		Locomotiva.plugin = this;
		this.criaLocomotiva = new CriaLocomotiva(this);
		sprites = new Imagens();
		this.locomotivas = new ArrayList(); 
		this.subestacoes = new ArrayList(); 
		log = this.getLogger();
		log.info("MinecartEngine foi habilitado!");
		this.ouveDestruicao = new OuvidorDestruicao(this);
		this.executa_comando = new Comandos(this);
		this.subestacao = new CriaSubestacao(this);
		this.ouveMinecart = new OuvidorMinecart(this);
		this.ouveColocaBloco = new OuvidorColocarBloco(this);
		this.ouveMudaBloco = new OuvidorMudancaBloco(this);
		this.getCommand("loco").setExecutor(criaLocomotiva);
		this.getCommand("substation").setExecutor(subestacao);
		this.getCommand("control").setExecutor(executa_comando);
		this.getCommand("df").setExecutor(executa_comando);
		this.getCommand("dn").setExecutor(executa_comando);
		this.getCommand("db").setExecutor(executa_comando);
		this.getCommand("p4").setExecutor(executa_comando);
		this.getCommand("p3").setExecutor(executa_comando);
		this.getCommand("p2").setExecutor(executa_comando);
		this.getCommand("p1").setExecutor(executa_comando);
		this.getCommand("neutral").setExecutor(executa_comando);
		this.getCommand("b1").setExecutor(executa_comando);
		this.getCommand("b2").setExecutor(executa_comando);
		this.getCommand("b3").setExecutor(executa_comando);
		this.getCommand("b4").setExecutor(executa_comando);
		//this.getServer().getPluginManager().registerEvents(this.breque, this);
		this.getServer().getPluginManager().registerEvents(this.ouveMinecart, this);
		this.getServer().getPluginManager().registerEvents(this.ouveColocaBloco, this);
		this.getServer().getPluginManager().registerEvents(this.ouveMudaBloco, this);
		this.getServer().getPluginManager().registerEvents(this.ouveDestruicao, this);
	}


	public void onDisable(){ 
		log.info("MinecartEngine foi desabilitado!");
	}

	public ArrayList getLocomotivas() {
		return locomotivas;
	}
}
