package com.gmail.pedrolucasnascimentoc;

import java.util.Iterator;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.block.Block;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;

public class OuvidorDestruicao implements Listener {
	MinecartEngine principal;

	public OuvidorDestruicao(MinecartEngine principal) {
		this.principal = principal;
	}

	@EventHandler
	public void aoMudarBloco(BlockBreakEvent bloco) {
		Block bloco_destruido = bloco.getBlock();
		if (bloco_destruido.getTypeId() == 69 || bloco_destruido.getTypeId() == 42 ||
				bloco_destruido.getTypeId() == 76 || bloco_destruido.getTypeId() == 113) {
			Iterator i  = principal.getSubestacoes().iterator();
			while(i.hasNext()) {
				
				Subestacao substation = (Subestacao) i.next();
				double X = substation.getPosicaoTrn().getX();
				double Y = substation.getPosicaoTrn().getY();
				double Z = substation.getPosicaoTrn().getZ();
				World mundo = substation.getPosicaoTrn().getWorld();
				if (new Location(mundo, X, Y, Z).getBlock().equals(bloco_destruido) ||
						new Location(mundo, (X + 1), Y, (Z + 1)).getBlock().equals(bloco_destruido) ||
						new Location(mundo, (X + 1), Y, Z).getBlock().equals(bloco_destruido) ||
						new Location(mundo, (X + 1), Y, (Z - 1)).getBlock().equals(bloco_destruido) ||

						new Location(mundo, (X - 1), Y, (Z + 1)).getBlock().equals(bloco_destruido) ||
						new Location(mundo, (X - 1), Y, Z).getBlock().equals(bloco_destruido) ||
						new Location(mundo, (X - 1), Y, (Z - 1)).getBlock().equals(bloco_destruido) ||

						new Location(mundo, X, Y, (Z + 1)).getBlock().equals(bloco_destruido) ||
						new Location(mundo, X, Y, (Z - 1)).getBlock().equals(bloco_destruido) ||

						new Location(mundo, X, (Y + 1), Z).getBlock().equals(bloco_destruido) ||
						new Location(mundo, (X + 1), (Y + 1), (Z + 1)).getBlock().equals(bloco_destruido) ||
						new Location(mundo, (X + 1), (Y + 1), Z).getBlock().equals(bloco_destruido) ||

						new Location(mundo, (X + 1), (Y + 1), (Z - 1)).getBlock().equals(bloco_destruido) ||
						new Location(mundo, (X - 1), (Y + 1), (Z + 1)).getBlock().equals(bloco_destruido) ||
						new Location(mundo, (X - 1), (Y + 1), Z).getBlock().equals(bloco_destruido) ||

						new Location(mundo, (X - 1), (Y + 1), (Z - 1)).getBlock().equals(bloco_destruido) ||
						new Location(mundo, X, (Y + 1), (Z + 1)).getBlock().equals(bloco_destruido) ||
						new Location(mundo, X, (Y + 1), (Z - 1)).getBlock().equals(bloco_destruido) ||

						new Location(mundo, X, (Y + 1), (Z + 1)).getBlock().equals(bloco_destruido) ||
						new Location(mundo, X, (Y + 1), (Z - 1)).getBlock().equals(bloco_destruido) ||
						new Location(mundo, (X + 1), (Y + 2), Z).getBlock().setTypeId(76) ||
						new Location(mundo, (X - 1), (Y + 2), Z).getBlock().setTypeId(76)) {
					substation.destruiu(true, bloco_destruido);			
					break;
				} else if (substation.getPosicaoLev().getBlock().equals(bloco_destruido)) {
					substation.destruiu(false, bloco_destruido);
					break;
				} else if (substation.getPosicaoCnx().getBlock().equals(bloco_destruido)) {
					break;
				}
			}
		}
	}
}